typedef struct Sess Sess;
typedef struct Node Node;
typedef struct Growbuf Growbuf;

struct Sess  {
	char *url;			/* host URL */
	Node *root;			/* root of tree */
	int conid;			/* /net connection ID */
	char *webfs;		/* mountpoint of webfs */
	int fd;				/* webfs session */
	Node **users;		/* root of /users directory */
};

struct Node {			/* filesystem hierarchy */
	Node *parent;
	Node *child;
	Node *next;
	char *path;
	Dir dir;
	long confirmed;		/* file/dir really does exist */
};

struct Growbuf {			/* growable buffer */
	int len;
	int alloc;
	char *buf;
};


extern int Dumpreq;
extern int Dumpparse;

/* http.c */
int exch(Sess *s, char *request, char *hdr, char *fmt, ...);
int ht_session(Sess *s);
long ht_get(Sess *s, char *path, char *buf, long len, vlong off);
long ht_put(Sess *s, char *path, char *buf, long len, vlong off);
long ht_head(Sess *s, char *path, vlong *length, ulong *mtime);
int ht_delete(Sess *s, char *path);

/* httperrstr.c */
void httperrstr(int n);

/* main.c */
void newpath(Sess *s, char *path, int mode, long mtime, vlong length);
void main(int argc, char *argv[]);

/* parse.c */
void *emalloc(ulong n);
void *erealloc(void *p, ulong n);
int resolve(Sess *s, Rune *base, Rune *href, char *path);
int parsebuf(Sess *s, char *path, Growbuf *gb);
int parse(Sess *s, char *path);

/* utils.c */
Growbuf *allocbuf(void);
void growbuf(Growbuf *gb, char *buf, int len);
void freebuf(Growbuf *gb);
