#include <u.h>
#include <libc.h>
#include <draw.h>
#include <html.h>
#include <fcall.h>
#include <thread.h>
#include <9p.h>
#include "httpfs.h"

Growbuf *
allocbuf(void)
{
	Growbuf *gb;

	gb = emalloc9p(sizeof(Growbuf));
	memset(gb, 0, sizeof(Growbuf));
	return gb;
}

void
growbuf(Growbuf *gb, char *buf, int len)
{
	if(gb->len + len >= gb->alloc){
		gb->alloc = gb->len + len + 1024;
		gb->buf = erealloc9p(gb->buf, gb->alloc);
	}
	memcpy(gb->buf + gb->len, buf, len);
	gb->len += len;
}

void
freebuf(Growbuf *gb)
{
	free(gb->buf);
	free(gb);
}



